import {IIngredient} from "./IIngredient";
import * as mongoose from "mongoose";
import {SensorType} from "../SensorType";

export interface IContainer extends mongoose.Document {
    _id: string,
    slot: number;
    content: IIngredient | undefined;
    volume: number;
    sensorDelta: number;
    sensorTare: number;
    // Sensor Type
    sensorType: SensorType;

    /**
     * HX711 DATA-Pin
     */
    sensorPin1: number;
    /**
     * HX711 CLOCK-Pin
     */
    sensorPin2: number;

    /**
     * Is the arduino used as proxy?
     */
    useProxy: boolean
    rawData: number;
    pumpPin: number;

    filled: number;
    enabled: boolean;
}